`timescale 1ns/1ps

`define wbclk_period 100
`define async_clk_period 63

`include "output/vlog_constants.v"

module main;
   reg clk=1;
   reg ram1_clk = 1;
   reg [31:0] rval;
   
   
   reg rst=0;

// generate clocks & reset
   always #(`wbclk_period/2) clk <= ~clk;
 

   initial #1000 rst <= 1;

`include "wishbone_stuff.v"

   function [4:0] decode_irq;
      input[31:0] isr_val;
      begin:decode_irq_body
       
	 integer i;
	 for(i=0; i<32; i=i+1) if(isr_val[i]) decode_irq = i;
	 
      end // UNMATCHED !!
   endfunction
    
      
      

   wire wb_irq;
   reg 	irq_rising_edge = 0;
   reg 	irq_falling_edge = 1;
   reg 	irq_level_hi = 0;
   reg 	irq_level_lo = 1;
   integer irqn;
   
  
  wb_test_interrupts
    dut(
	.rst_n_i   (rst),
	.wb_clk_i  (clk),
	.wb_addr_i (wb_addr[1:0]),
	.wb_data_i (wb_data_o),
	.wb_data_o (wb_data_i),
	.wb_cyc_i  (wb_cyc),
	.wb_sel_i  (wb_bwsel),
	.wb_stb_i  (wb_stb),
	.wb_we_i   (wb_we),
	.wb_ack_o  (wb_ack),

	.wb_irq_o  (wb_irq),

	.irq_ipe_i (irq_rising_edge),
	.irq_ine_i  (irq_falling_edge),         
	.irq_il0_i  (irq_level_lo ),            
	.irq_il1_i  (irq_level_hi )
  );
   
   integer     i;
   integer fail = 0;

      
   initial begin
      #2000; @(posedge clk); #1; // wait until the DUT is reset       

      $display("Configure the interrupt controller - enable all interrupts");

      wb_verbose(1);
      wb_write(`ADDR_TESTIRQ_EIC_IER, 'hf);
   end

   initial begin
      #10000; irq_rising_edge <= 1;
      
      

   end

   always@(wb_irq) begin
      if(wb_irq == 1) begin
	 @(posedge clk); #1; // wait until the DUT is reset       

	 wb_read(`ADDR_TESTIRQ_EIC_ISR, rval);
	 irqn = decode_irq(rval);
	 
	 $display("Got interrupt: %d", irqn);
	 // acknowledge the interrupts
	 wb_write(`ADDR_TESTIRQ_EIC_ISR, (1<<irqn));
	 $display("Acknowledged IRQ: %d", irqn);
	 
      end
   end

endmodule
